VERSION 5.00
Begin VB.Form frmTurret 
   BackColor       =   &H00000000&
   BorderStyle     =   0  'None
   Caption         =   "Joe's First D3D"
   ClientHeight    =   5760
   ClientLeft      =   -15
   ClientTop       =   0
   ClientWidth     =   7680
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   384
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   512
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   WindowState     =   2  'Maximized
End
Attribute VB_Name = "frmTurret"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
DefInt I
Dim DX As DirectDraw2
Dim Running As Boolean
Dim D3DRM As Direct3DRM
Dim Scene As Direct3DRMFrame
Dim Camera As Direct3DRMFrame
Dim Clipper As DirectDrawClipper
Dim Device As Direct3DRMDevice
Dim Viewport As Direct3DRMViewPort
Dim LightFrame As Direct3DRMFrame
Dim light As Direct3DRMLight

Dim TurretFrame As Direct3DRMFrame
Dim TurretBarrelFrame As Direct3DRMFrame
Dim Turret As Direct3DRMMeshBuilder
Dim TurretBarrel As Direct3DRMMeshBuilder
Dim TurretMat As Direct3DMaterial

Dim BeamFrame As Direct3DRMFrame
Dim BeamLight As Direct3DRMLight
Dim Beam As Direct3DRMMeshBuilder
Dim BeamActive As Boolean

Dim TurretPos As TurretStat

Const PI = 3.14159269
Public Sub CreateTurretBarrel(barrel As Direct3DRMMeshBuilder)
    Const p = 10
    Dim Vert(p * 2 - 1) As D3DVECTOR
    Dim Norm(0) As D3DVECTOR
    Dim Faces(100) As Long
    Dim IPtr As Integer
    
    ' Make a circles for top and bottom
    For i = 0 To p - 1
        ' Bottom
        Vert(i).X = Cos(2! * PI / p * i) * 0.2
        Vert(i).Y = Sin(2! * PI / p * i) * 0.2
        Vert(i).z = 0
        ' Top
        Vert(i + p).X = Vert(i).X
        Vert(i + p).Y = Vert(i).Y
        Vert(i + p).z = 1.5
    Next
    
    IPtr = 0
    ' Do index for bottom circle
    Faces(IPtr) = p: IPtr = IPtr + 1
    For i = p - 1 To 0 Step -1
        Faces(IPtr) = i: IPtr = IPtr + 1
    Next
    ' Do index for bottom circle(do backwards for CCW)
    Faces(IPtr) = p: IPtr = IPtr + 1
    For i = p To 2 * p - 1
        Faces(IPtr) = i: IPtr = IPtr + 1
    Next
    
    'Make the long peices
    For i = 0 To p - 2
        Faces(IPtr) = 4: IPtr = IPtr + 1
        Faces(IPtr) = i: IPtr = IPtr + 1
        Faces(IPtr) = i + 1: IPtr = IPtr + 1
        Faces(IPtr) = i + p + 1: IPtr = IPtr + 1
        Faces(IPtr) = i + p: IPtr = IPtr + 1
    Next
    ' Last peice
    Faces(IPtr) = 4: IPtr = IPtr + 1
    Faces(IPtr) = p - 1: IPtr = IPtr + 1
    Faces(IPtr) = 0: IPtr = IPtr + 1
    Faces(IPtr) = p: IPtr = IPtr + 1
    Faces(IPtr) = 2 * p - 1: IPtr = IPtr + 1
    
    'Terminate list
    Faces(IPtr) = 0
    
    ' Add faces to the mesh
    barrel.AddFaces p * 2, Vert(0), 0, Norm(0), Faces(0), Nothing
    barrel.GenerateNormals
    
    barrel.SetColorRGB 0.36, 0.36, 0.44
    ' Set material properties
    Dim Mat As Direct3DRMMaterial
    D3DRM.CreateMaterial 5, Mat
     ' Set Emmisive property(Emmited light)
    Mat.SetEmissive 0.1, 0.1, 0.1
     ' Set Specular highlight color and power
    Mat.SetSpecular 0.69, 0.69, 0.75
    
    ' Assign material to turret
    barrel.SetMaterial Mat
    
    Set Mat = Nothing
    
End Sub

Private Sub Form_KeyPress(KeyAscii As Integer)
    Dim up As D3DVECTOR, dir As D3DVECTOR
    Dim DoTurret As Boolean, DoBarrel As Boolean
        
    On Error Resume Next
    
    Const BearingAdjust = 10! * PI / 180!
    Const TurretAdjust = 2! * PI / 180!
    Const TurretMax = 66! * PI / 180!
    Const TurretMin = -10 * PI / 180!
    Const Spd = 0.5
    If KeyAscii = vbKeyEscape Then
        Unload Me
    End If
    DoTurret = False: DoBarrel = False
    With TurretPos
        Select Case LCase$(Chr$(KeyAscii))
            Case "+"
                .pos.z = .pos.z - 0.05
                DoTurret = True
            Case "-"
                .pos.z = .pos.z + 0.05
                DoTurret = True
            Case "a"
                .bearing = .bearing + BearingAdjust
                DoTurret = True
            Case "d"
                .bearing = .bearing - BearingAdjust
                DoTurret = True
            Case "w"
                .elevation = .elevation + TurretAdjust
                DoBarrel = True
            Case "s"
                .elevation = .elevation - TurretAdjust
                DoBarrel = True
            Case " "
                If BeamActive Then
                    ' Kill beam
                    Scene.DeleteChild BeamFrame
                    BeamActive = False
                Else
                    ' Start beam pointed in turret direction
                    Scene.AddChild BeamFrame
                    TurretBarrelFrame.GetOrientation Scene, dir, up
                    BeamFrame.SetOrientation Scene, dir.X, dir.Y, dir.z, up.X, up.Y, up.z
                    BeamFrame.SetPosition TurretBarrelFrame, 0, 0, 1.5
                    BeamFrame.SetVelocity Scene, dir.X * Spd, dir.Y * Spd, dir.z * Spd, 0
                    BeamActive = True
                End If
        End Select
            
        ' Adjust entire turret bearing
        If DoTurret Then
          TurretFrame.SetOrientation Scene, 0, 1, 0, 0, 0, 1
          TurretFrame.AddRotation D3DRMCOMBINE_AFTER, 0, 1, 0, .bearing
          TurretFrame.SetPosition Scene, .pos.X, .pos.Y, .pos.z
        End If
        
        ' Adjust turret barrel elevation
        If DoBarrel Then
          If .elevation < TurretMin Then .elevation = TurretMin
          If .elevation > TurretMax Then .elevation = TurretMax
          TurretBarrelFrame.SetOrientation TurretFrame, -1, 0, 0, 0, 0, 1
          TurretBarrelFrame.AddRotation D3DRMCOMBINE_AFTER, 0, 1, 0, .elevation
          TurretBarrelFrame.SetPosition TurretFrame, -0.8, 0, 0.25
        End If
    End With
End Sub

Private Sub Form_Load()
    ' Explain key's 'n stuff
    MsgBox ("These are the keys:" + Chr$(13) + " a      Rotate turret CW" + Chr$(13) + " d      Rotate turret CCW" + Chr$(13) + " w      Raise the barrel" + Chr$(13) + " s      Lower the barrel" + Chr$(13) + " space  Shoot/Stop laser beam")
    ' Get interface for Direct3D
    frmTurret.Show
    DirectDrawCreate ByVal 0&, DX, Nothing
    DX.SetCooperativeLevel Me.hWnd, DDSCL_NORMAL 'DDSCL_EXCLUSIVE Or DDSCL_FULLSCREEN
    DX.SetDisplayMode 640, 480, 16, 0, 0
    
    Direct3DRMCreate D3DRM
    
    ' Create Scene(root frame)
    D3DRM.CreateFrame Nothing, Scene
    
    ' Make the camera
    D3DRM.CreateFrame Scene, Camera
    Camera.SetPosition Scene, 0, 0, 10
    
    ' Make clipper for window
    DirectDrawCreateClipper 0&, Clipper, Nothing
    Clipper.SetHWnd 0, Me.hWnd
    ' Find RGB(not Ramp) device
    Dim d3ddev As Direct3DDevice, d3d As Direct3D
     'Temporary device to get a GUID for a D3DCOLOR_RGB device
    D3DRM.CreateDeviceFromClipper Clipper, ByVal 0&, Me.ScaleWidth, Me.ScaleHeight, Device
    Device.GetDirect3DDevice d3ddev: Set Device = Nothing
    d3ddev.GetDirect3D d3d: Set d3ddev = Nothing
    Dim searchdata As D3DFINDDEVICESEARCH
    Dim resultdata As D3DFINDDEVICERESULT
    searchdata.dwSize = Len(searchdata)
    searchdata.dwFlags = D3DFDS_COLORMODEL
    searchdata.dcmColorModel = D3DCOLOR_RGB
    resultdata.dwSize = Len(resultdata)
    d3d.FindDevice searchdata, resultdata
    Set d3d = Nothing
    If resultdata.GUID.Data1 = 0 Then
        'No compatible device found
        MsgBox ("Error: No RGB-Lighting compatible device found!")
        End
    End If
         
    ' Make device and viewport
    D3DRM.CreateDeviceFromClipper Clipper, resultdata.GUID, Me.ScaleWidth, Me.ScaleHeight, Device
    D3DRM.CreateViewport Device, Camera, 0, 0, Device.GetWidth, Device.GetHeight, Viewport
    Viewport.SetBack 5000&
    Device.SetQuality D3DRMLIGHT_ON Or D3DRMFILL_SOLID Or D3DRMSHADE_GOURAUD
    Device.SetDither 1
        
    ' Make the general scene light
    D3DRM.CreateFrame Scene, LightFrame
    D3DRM.CreateLightRGB D3DRMLIGHT_DIRECTIONAL, 0.8, 0.8, 0.8, light
    LightFrame.AddLight light
    LightFrame.SetPosition Scene, 0, 5, 0
     
    ' Add an ambient light
    Dim LightAmbient As Direct3DRMLight
    D3DRM.CreateLightRGB D3DRMLIGHT_AMBIENT, 0.15, 0.15, 0.15, LightAmbient
    Scene.AddLight LightAmbient
    
    ' Make the turret box
    D3DRM.CreateFrame Scene, TurretFrame
    With TurretPos
        .bearing = 0
        TurretFrame.SetOrientation Scene, 0, 1, 0, 0, 0, 1
        With .pos
            .X = 0
            .Y = -0.5
            .z = 5
            TurretFrame.SetPosition Scene, .X, .Y, .z
        End With
    End With
    
    'TurretFrame.SetRotation Scene, 1, 1, 1, 0.17
    
    D3DRM.CreateMeshBuilder Turret
    CreateTurretBox Turret
     ' Do material stuff
    TurretFrame.AddVisual Turret
    
    ' Make turret barrel
    D3DRM.CreateFrame TurretFrame, TurretBarrelFrame
    D3DRM.CreateMeshBuilder TurretBarrel
    CreateTurretBarrel TurretBarrel
    TurretBarrelFrame.AddVisual TurretBarrel
    
    TurretBarrelFrame.SetOrientation TurretFrame, -1, 0, 0, 0, 0, 1
    TurretBarrelFrame.AddRotation D3DRMCOMBINE_AFTER, 0, 1, 0, 0
    TurretPos.elevation = 0
    TurretBarrelFrame.SetPosition TurretFrame, -0.8, 0, 0.25
            
    ' Define beam shape
    D3DRM.CreateFrame Nothing, BeamFrame
    D3DRM.CreateMeshBuilder Beam
    CreateBeam Beam, BeamLight, 1
    BeamLight.SetLinearAttenuation 0.4
    BeamFrame.AddVisual Beam
    BeamFrame.AddLight BeamLight
    BeamActive = False
        
    ' Move camera
    Camera.SetPosition Scene, 0, 1.8, 0
     'Camera.SetOrientation Scene, 0, 0, 1, 0, 1, 0
    Camera.LookAt TurretFrame, Scene, D3DRMCONSTRAIN_Z
        
    ' Deallocate unneeded objects
    Set LightFrame = Nothing
    Set light = Nothing
       
    'Me!Refresh.Enabled = True
        On Error GoTo Refresh_D3D_Error
    Running = True
   
    Do While Running = True
        Scene.Move 1
        Viewport.Clear
        Viewport.Render Scene
        Device.Update
        DoEvents
    Loop
    Exit Sub
Refresh_D3D_Error:
    Resume
End Sub

Private Sub Form_Unload(Cancel As Integer)
Running = False
Set BeamFrame = Nothing
Set BeamLight = Nothing
Set Beam = Nothing
Set BeamMat = Nothing

Set TurretFrame = Nothing
Set TurretBarrelFrame = Nothing
Set Turret = Nothing
Set TurretBarrel = Nothing
Set TurretMat = Nothing

Set LightFrame = Nothing
Set light = Nothing
Set Viewport = Nothing
Set Device = Nothing
Set Clipper = Nothing
Set Camera = Nothing
Set Scene = Nothing
Set D3DRM = Nothing

End Sub



Public Sub CreateTurretBox(Turret As Direct3DRMMeshBuilder)
    Dim Vert(7) As D3DVECTOR
    Dim Norm(0) As D3DVECTOR
    Dim Faces(100) As Long
    Dim IPtr As Integer
    
    ' Make the last 4 points a square for bottom
    Vert(4).X = 1: Vert(4).Y = 1: Vert(4).z = 0
    Vert(5).X = 1: Vert(5).Y = -1: Vert(5).z = 0
    Vert(6).X = -1: Vert(6).Y = -1: Vert(6).z = 0
    Vert(7).X = -1: Vert(7).Y = 1: Vert(7).z = 0
    
    ' Make top square 3/4 of the bottom square
    For i = 0 To 3
        With Vert(i)
            .X = Vert(i + 4).X * 0.75
            .Y = Vert(i + 4).Y * 0.75
            .z = 0.75
        End With
    Next
    
    ' Make indexes
    IPtr = 0
    ' Top (top is backwards)
    Faces(IPtr) = 4: IPtr = IPtr + 1
    Faces(IPtr) = 3: IPtr = IPtr + 1
    Faces(IPtr) = 2: IPtr = IPtr + 1
    Faces(IPtr) = 1: IPtr = IPtr + 1
    Faces(IPtr) = 0: IPtr = IPtr + 1
    ' Bottom
    Faces(IPtr) = 4: IPtr = IPtr + 1
    Faces(IPtr) = 4: IPtr = IPtr + 1
    Faces(IPtr) = 5: IPtr = IPtr + 1
    Faces(IPtr) = 6: IPtr = IPtr + 1
    Faces(IPtr) = 7: IPtr = IPtr + 1
    ' Front Side(-y)
    Faces(IPtr) = 4: IPtr = IPtr + 1
    Faces(IPtr) = 7: IPtr = IPtr + 1
    Faces(IPtr) = 6: IPtr = IPtr + 1
    Faces(IPtr) = 2: IPtr = IPtr + 1
    Faces(IPtr) = 3: IPtr = IPtr + 1
    ' Back Side(+y)
    Faces(IPtr) = 4: IPtr = IPtr + 1
    Faces(IPtr) = 5: IPtr = IPtr + 1
    Faces(IPtr) = 4: IPtr = IPtr + 1
    Faces(IPtr) = 0: IPtr = IPtr + 1
    Faces(IPtr) = 1: IPtr = IPtr + 1
    ' Left Side(-x)
    Faces(IPtr) = 4: IPtr = IPtr + 1
    Faces(IPtr) = 6: IPtr = IPtr + 1
    Faces(IPtr) = 5: IPtr = IPtr + 1
    Faces(IPtr) = 1: IPtr = IPtr + 1
    Faces(IPtr) = 2: IPtr = IPtr + 1
    ' Right Side(+x)
    Faces(IPtr) = 4: IPtr = IPtr + 1
    Faces(IPtr) = 4: IPtr = IPtr + 1
    Faces(IPtr) = 7: IPtr = IPtr + 1
    Faces(IPtr) = 3: IPtr = IPtr + 1
    Faces(IPtr) = 0: IPtr = IPtr + 1

    ' Terminate List
    Faces(IPtr) = 0
    
    
    ' Add faces to the mesh
    Turret.AddFaces 8, Vert(0), 0, Norm(0), Faces(0), Nothing
    Turret.GenerateNormals
    
    Turret.SetColorRGB 0.36, 0.36, 0.44
    ' Set material properties
    Dim Mat As Direct3DRMMaterial
    D3DRM.CreateMaterial 5, Mat
     ' Set Emmisive property(Emmited light)
    Mat.SetEmissive 0.1, 0.1, 0.1
     ' Set Specular highlight color and power
    Mat.SetSpecular 0.69, 0.69, 0.75
    
    ' Assign material to turret
    Turret.SetMaterial Mat
    
    Set Mat = Nothing
End Sub

Public Sub CreateBeam(Beam As Direct3DRMMeshBuilder, light As Direct3DRMLight, col As Integer)
    Dim Vert(5) As D3DVECTOR
    Dim Norm(0) As D3DVECTOR
    Dim Faces(100) As Long
    Dim IPtr As Integer
    Dim Red As Integer, Green As Integer, Blue As Integer
    
    'Get colors
    If col And 1 Then Red = 1 Else Red = 0
    If col And 2 Then Green = 1 Else Green = 0
    If col And 4 Then Blue = 1 Else Blue = 0
    
    For i = 0 To 2
        ' Top triangle
        Vert(i).X = Cos(2 * PI / 3 * i) * 0.03
        Vert(i).Y = Sin(2 * PI / 3 * i) * 0.03
        Vert(i).z = 0.4
        ' Bottom triangle
        Vert(i + 3).X = Vert(i).X
        Vert(i + 3).Y = Vert(i).Y
        Vert(i + 3).z = -Vert(i).X
    Next
    
    IPtr = 0
    ' Top
    Faces(IPtr) = 3: IPtr = IPtr + 1
    Faces(IPtr) = 0: IPtr = IPtr + 1
    Faces(IPtr) = 1: IPtr = IPtr + 1
    Faces(IPtr) = 2: IPtr = IPtr + 1
    
    ' Bottom
    Faces(IPtr) = 3: IPtr = IPtr + 1
    Faces(IPtr) = 5: IPtr = IPtr + 1
    Faces(IPtr) = 4: IPtr = IPtr + 1
    Faces(IPtr) = 3: IPtr = IPtr + 1
    
    ' Side 1
    Faces(IPtr) = 4: IPtr = IPtr + 1
    Faces(IPtr) = 0: IPtr = IPtr + 1
    Faces(IPtr) = 3: IPtr = IPtr + 1
    Faces(IPtr) = 4: IPtr = IPtr + 1
    Faces(IPtr) = 2: IPtr = IPtr + 1
    
    ' Side 2
    Faces(IPtr) = 4: IPtr = IPtr + 1
    Faces(IPtr) = 1: IPtr = IPtr + 1
    Faces(IPtr) = 4: IPtr = IPtr + 1
    Faces(IPtr) = 5: IPtr = IPtr + 1
    Faces(IPtr) = 3: IPtr = IPtr + 1
    
    ' Side 3
    Faces(IPtr) = 4: IPtr = IPtr + 1
    Faces(IPtr) = 2: IPtr = IPtr + 1
    Faces(IPtr) = 5: IPtr = IPtr + 1
    Faces(IPtr) = 3: IPtr = IPtr + 1
    Faces(IPtr) = 0: IPtr = IPtr + 1
    
    ' Terminate List
    Faces(IPtr) = 0
    
    ' Add faces to the mesh
    Beam.AddFaces 6, Vert(0), 0, Norm(0), Faces(0), Nothing
    Beam.GenerateNormals
    
    Beam.SetColorRGB Red, Green, Blue
    ' Set material properties
    Dim Mat As Direct3DRMMaterial
    D3DRM.CreateMaterial 0, Mat
     ' Set Emmisive property(Emmited light)
    Mat.SetEmissive Red, Green, Blue
     ' Set Specular highlight color and power
    Mat.SetSpecular 0, 0, 0
    
    ' Assign material to turret
    Beam.SetMaterial Mat
    
    Set Mat = Nothing

    ' Make light same coloR
    D3DRM.CreateLightRGB D3DRMLIGHT_POINT, Red, Green, Blue, light
End Sub
